Core - Task # 52589

Epic # 55070 (Accepted): Workpackages
Epic # 54260 (Accepted): WP: FAL Missing Issues / Features / API
Story # 54261 (Resolved): As an Extension-Developer | want to use FAL assets in my custom development

Status: Resolved Priority: Should have

Author: Bernhard Kraft Category: File Abstraction Layer (FAL)
Created: 2013-10-07 Assigned To: Steffen Ritter

Updated: 2014-01-31 Due date:

TYPOS3 Version: 6.2

PHP Version: 5.4

Complexity: easy

Sprint Focus:

Subject: Method for direct output of file

Description

In PHP there is a method called "readfile" which allows to directly output a file to output stream. This allows to output files larger than
the available amount of memory because the whole file doesn't have to get read into memory.

Such a method is missing for FAL. There should be some method "outputContent" which reads in file data in chunks and outputs them
using "echo".

Or propose another solution for sending large files to the browser.

Associated revisions

Revision 3ac80662 - 2014-01-30 19:14 - Steffen Ritter

[TASK] Add possibility to dump file to browser

The FileAbstractionLayer currently only provides the possibility to

retrieve the contents of a file as a string. If you want to output

a file this would lead to a massive memory overhead for large files

when building some kind of download/jumpurl/access-restricted download

script.

This change adds a method "dumpFileContents" to the ResourceStorage
allowing to directly output the contents of the file including setting
correct headers.

In addition it introduces a new method (same name) in the DriverInterface

and implements it in the LocalDriver.

Resolves: #52589

Releases: 6.2

Change-Id: 1050da59b136fafbf3f05ac814bd3f11f20ae2396
Reviewed-on: https://review.typo3.org/26835

Reviewed-by: Frans Saris
Reviewed-by: Philipp Gampe
Reviewed-by: Ingo Schmitt
Reviewed-by: Sebastian Fischer
Tested-by: Sebastian Fischer
Reviewed-by: Benjamin Mack

Tested-by: Benjamin Mack

Revision 5ce03514 - 2014-01-31 21:06 - Benjamin Mack

[BUGFIX] FAL: Followup to New dump file to browser

Cache control headers need to be sent for IE8 and
HTTPS combination. See #16491 for more details.

Resolves: #52589

Releases: 6.2

Change-Id: 1746820dbbb8ca40a9db7e474ac9aaa7ee3d2fb33
Reviewed-on: https://review.typo3.org/27217

Reviewed-by: Benjamin Mack

Tested-by: Benjamin Mack

History

#1 - 2013-10-07 17:52 - Oliver Hader
- Target version deleted (next-patchlevel)

Well, you can determine the URI of the file and output it by individual stream handlers.
If the URlI is public readable as well, a HTTP location header would be enough.

#2 - 2013-10-08 11:16 - Bernhard Kraft

If the URl is not public readable | am stuck to stream handlers. It would be nice to have an abstract way of doing this instead of having to implement

for every possible storage driver.

Note that | set this as "should have" and "feature". So ... no hassle.

#3 - 2013-11-30 17:02 - Steffen Ritter

- Status changed from New to Accepted
- Assigned To set to Steffen Ritter

- Target version set to 6.2.0

#4 - 2013-12-06 11:54 - Steffen Ritter
- Estimated time set to 1.00

- Complexity changed from medium to easy

#5 - 2013-12-07 14:58 - Steffen Ritter
- Parent task set to #54261

#6 - 2014-01-15 14:54 - Steffen Ritter
- % Done changed from 0 to 40

- Remaining (hours) set to 1.0

#7 - 2014-01-15 14:54 - Steffen Ritter
- Target version set to 6.2.0
#8 - 2014-01-15 14:59 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26835

#9 - 2014-01-30 19:30 - Steffen Ritter
- Status changed from Under Review to Resolved
- % Done changed from 40 to 100

Applied in changeset commit:3ac80662f3cd00efc0a99357618de8c54f2f64c2.

#10 - 2014-01-31 09:47 - Bernhard Kraft

Thanks for taking care of those FAL issues !

#11 - 2014-01-31 21:05 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27217

#12 - 2014-01-31 21:30 - Benjamin Mack
- Status changed from Under Review to Resolved

Applied in changeset commit:5ce03514991cf1500e0b5d6d0772b162a9fff93e.
